//
//  UIBezierPath+LxThroughPointsBezier.h
//  LxThroughPointsBezierDemo
//

#import <UIKit/UIKit.h>

@interface UIBezierPath (LxThroughPointsBezier)

/**
 *  The curve‘s bend level. The good value is about 0.6 ~ 0.8. The default and recommended value is 0.7.
 *  收缩因素（倍数），0-1，调整曲线的弯曲度，自己可设。

 */
@property (nonatomic) CGFloat contractionFactor;

/**
 *  You must wrap CGPoint struct to NSValue object.
 *
 *  @param pointArray Points you want to through. You must give at least 1 point for drawing curve.
 */
- (void)addBezierThroughPoints:(NSArray *)pointArray;   // 数字数组

/**
 *  传入一个数字数组，画线
 *  @param numberArray              传入一个数组，数字数组。记住数组的第一个元素是起始点，为0。所以传入的数组要为[@“0”，@“5”...]，否则刚开始两点会画一条直线。 
 *  @param roundPoint               坐标原点位置
 *  @param distanceLineX            X分割线距离
 *  @param distanceLineY            Y分割线距离
 */
- (void)addBezierThroughPointsByNumberArray:(NSArray *)numberArray andRoundPoint:(CGPoint) roundPoint andDistanceLineX:(CGFloat) distanceLineX andDistanceLineY:(CGFloat)distanceLineY;

@end
