//
//  ViewController.m
//  TextQuXianView
//
//  Created by zhuochunsheng on 16/6/17.
//  Copyright © 2016年 fenda. All rights reserved.
//

#import "ViewController.h"
#import "UIBezierPath+LxThroughPointsBezier.h"

@interface ViewController ()<UITextFieldDelegate>
{
    CAShapeLayer *shapeLayer;
    UIButton *huituButton;
    UITextField *arrayTextField;
    NSMutableArray *numberArray;
    
    // 四个textField
    UITextField *xQiShiDianZuoBiao;
    UITextField *yQiShiDianZuoBiao;
    UITextField *xZhuoDistance;
    UITextField * yZhuoDistance;
    // 四个label
    UILabel *xQiShiDianZuoBiaoLabel;
    UILabel *yQiShiDianZuoBiaoLabel;
    UILabel *xZhuoDistanceLabel;
    UILabel *yZhuoDistanceLabel;
    // 四个参数
    NSString *xqishi;
    NSString *yqishi;
    NSString *xjianxi;
    NSString *yjianxi;
}
@end

@implementation ViewController

// textFieldDelegate
- (void)textFieldDidEndEditing:(UITextField *)textField
{
    
    xqishi = [NSString stringWithFormat:@"%@",xQiShiDianZuoBiao.text];
    yqishi = [NSString stringWithFormat:@"%@",yQiShiDianZuoBiao.text];
    xjianxi = [NSString stringWithFormat:@"%@",xZhuoDistance.text];
    yjianxi = [NSString stringWithFormat:@"%@",yZhuoDistance.text];
}

- (void)huitu
{
    [shapeLayer removeFromSuperlayer];
    numberArray = (NSMutableArray *)[arrayTextField.text componentsSeparatedByString:@","];
    UIBezierPath *path = [UIBezierPath bezierPath];
    
    // 起始点
    [path moveToPoint:CGPointMake(xqishi.integerValue, yqishi.integerValue)];
    // 画路径
    [path addBezierThroughPointsByNumberArray:numberArray andRoundPoint:CGPointMake(xqishi.integerValue, yqishi.integerValue) andDistanceLineX:xjianxi.integerValue andDistanceLineY:yjianxi.integerValue];
    shapeLayer = [CAShapeLayer layer];
    shapeLayer.path = path.CGPath;
    shapeLayer.strokeColor = [UIColor blueColor].CGColor;
    shapeLayer.fillColor = [UIColor clearColor].CGColor;
    shapeLayer.lineWidth = 3;
    shapeLayer.lineCap = kCALineCapRound;
    [self.view.layer addSublayer:shapeLayer];
    [self addAnimationOneOnLayer:shapeLayer duration:1];
}

- (void)addAnimationOneOnLayer:(CAShapeLayer *)layer duration:(CFTimeInterval)duration
{
    CABasicAnimation *animation = [CABasicAnimation animationWithKeyPath:@"strokeEnd"];
    animation.fromValue = @(0);
    animation.toValue = @(1);
    animation.duration = duration;
    [layer addAnimation:animation forKey:nil];
}

- (void)addUpChildViews
{
    CGFloat textFieldY = 30;
    CGFloat textFieldW = 70;
    CGFloat textFieldH = 30;
    // 起始点x
    xQiShiDianZuoBiao = [[UITextField alloc] initWithFrame:CGRectMake(20, textFieldY, textFieldW, textFieldH)];
    xQiShiDianZuoBiaoLabel = [[UILabel alloc] initWithFrame:CGRectMake(20, CGRectGetMaxY(xQiShiDianZuoBiao.frame) + 10, textFieldW, textFieldH)];
    xQiShiDianZuoBiaoLabel.textAlignment = NSTextAlignmentCenter;
    xQiShiDianZuoBiaoLabel.text = @"起始点X";
    xQiShiDianZuoBiaoLabel.textColor = [UIColor blackColor];
    xQiShiDianZuoBiao.delegate = self;
    
    // 起始点Y
    yQiShiDianZuoBiao = [[UITextField alloc] initWithFrame:CGRectMake(CGRectGetMaxX(xQiShiDianZuoBiao.frame) + 15, textFieldY, textFieldW, textFieldH)];
    yQiShiDianZuoBiaoLabel = [[UILabel alloc] initWithFrame:CGRectMake(CGRectGetMaxX(xQiShiDianZuoBiao.frame) + 15, CGRectGetMaxY(xQiShiDianZuoBiao.frame) + 10, textFieldW, textFieldH)];
    yQiShiDianZuoBiaoLabel.textAlignment = NSTextAlignmentCenter;
    yQiShiDianZuoBiaoLabel.text = @"起始点Y";
    yQiShiDianZuoBiaoLabel.textColor = [UIColor blackColor];
    yQiShiDianZuoBiao.delegate = self;
    
    // x轴间隙
    xZhuoDistance = [[UITextField alloc] initWithFrame:CGRectMake(CGRectGetMaxX(yQiShiDianZuoBiao.frame) + 15, textFieldY, textFieldW, textFieldH)];
    xZhuoDistanceLabel = [[UILabel alloc] initWithFrame:CGRectMake(CGRectGetMaxX(yQiShiDianZuoBiao.frame) + 15, CGRectGetMaxY(xZhuoDistance.frame) + 10, textFieldW, textFieldH)];
    xZhuoDistanceLabel.textAlignment = NSTextAlignmentCenter;
    xZhuoDistanceLabel.text = @"x轴间隙";
    xZhuoDistanceLabel.textColor = [UIColor blackColor];
    xZhuoDistance.delegate = self;
    
    // y轴间隙
    yZhuoDistance = [[UITextField alloc] initWithFrame:CGRectMake(CGRectGetMaxX(xZhuoDistance.frame) + 15, textFieldY, textFieldW, textFieldH)];
    yZhuoDistanceLabel = [[UILabel alloc] initWithFrame:CGRectMake(CGRectGetMaxX(xZhuoDistance.frame) + 15, CGRectGetMaxY(yZhuoDistance.frame) + 10, textFieldW, textFieldH)];
    yZhuoDistanceLabel.textAlignment = NSTextAlignmentCenter;
    yZhuoDistanceLabel.text = @"y轴间隙";
    yZhuoDistanceLabel.textColor = [UIColor blackColor];
    yZhuoDistance.delegate = self;
    
    xQiShiDianZuoBiao.layer.borderWidth =1;
    xQiShiDianZuoBiao.layer.borderColor = [UIColor lightGrayColor].CGColor;
    
    xZhuoDistance.layer.borderWidth =1;
    xZhuoDistance.layer.borderColor = [UIColor lightGrayColor].CGColor;

    yQiShiDianZuoBiao.layer.borderWidth =1;
    yQiShiDianZuoBiao.layer.borderColor = [UIColor lightGrayColor].CGColor;

    yZhuoDistance.layer.borderWidth =1;
    yZhuoDistance.layer.borderColor = [UIColor lightGrayColor].CGColor;

    
    [self.view addSubview:xQiShiDianZuoBiao];
    [self.view addSubview:yQiShiDianZuoBiao];
    [self.view addSubview:xZhuoDistance];
    [self.view addSubview:yZhuoDistance];
    [self.view addSubview:xQiShiDianZuoBiaoLabel];
    [self.view addSubview:yQiShiDianZuoBiaoLabel];
    [self.view addSubview:xZhuoDistanceLabel];
    [self.view addSubview:yZhuoDistanceLabel];
    
    // 输入数组的textField
    arrayTextField = [[UITextField alloc] initWithFrame:CGRectMake(20, CGRectGetMaxY(xQiShiDianZuoBiaoLabel.frame) + 15, 300, 40)];
    arrayTextField.delegate = self;
    arrayTextField.layer.borderColor = [UIColor lightGrayColor].CGColor;
    arrayTextField.layer.borderWidth = 1;
    [self.view addSubview:arrayTextField];
    
    
    // 绘图button
    huituButton = [[UIButton alloc] initWithFrame:CGRectMake(100, CGRectGetMaxY(arrayTextField.frame) + 15, 100, 40)];
    [huituButton setTitle:@"绘图" forState:UIControlStateNormal];
    [huituButton setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
    [huituButton setBackgroundColor:[UIColor yellowColor]];
    [huituButton addTarget:self action:@selector(huitu) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:huituButton];
}

- (void)labelClose
{
    if([xQiShiDianZuoBiao isEditing] == YES)
        [xQiShiDianZuoBiao endEditing:YES];
    if([yQiShiDianZuoBiao isEditing] == YES)
        [yQiShiDianZuoBiao endEditing:YES];
    if([xZhuoDistance isEditing] == YES)
        [xZhuoDistance endEditing:YES];
    if([yZhuoDistance isEditing] == YES)
        [yZhuoDistance endEditing:YES];
    if([arrayTextField isEditing] == YES)
        [arrayTextField endEditing:YES];
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    [self addUpChildViews];
    UITapGestureRecognizer *gesture = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(labelClose)];
    [self.view addGestureRecognizer:gesture];
    
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


@end
